OGRE-Next: Ogre::v1::TagPoint Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::v1::TagPoint Class Reference
Core » Animation

A tagged point on a skeleton, which can be used to attach entities to on specific other entities. More...

`#include <OgreTagPoint.h>`

Inheritance diagram for Ogre::v1::TagPoint:
[legend]

## Public Member Functions
| TagPoint (unsigned short handle, Skeleton *creator)
| ~TagPoint () override
const Matrix4 & | _getFullLocalTransform () const
| Gets the transform of this node just for the skeleton (not entity).
MovableObject * | getChildObject () const
bool | getInheritParentEntityOrientation () const
| Returns true if this TagPoint is affected by orientation applied to the parent entity.
bool | getInheritParentEntityScale () const
| Returns true if this TagPoint is affected by scaling factors applied to the parent entity.
const LightList & | getLights () const
| Gets a list of lights, ordered relative to how close they are to this renderable.
Entity * | getParentEntity () const
const Matrix4 & | getParentEntityTransform () const
| Gets the transform of parent entity.
void | needUpdate (bool forceParentUpdate=false) override
| To be called in the event of transform changes to this OldNode that require it's recalculation.
void | setChildObject (MovableObject *pObject)
void | setInheritParentEntityOrientation (bool inherit)
| Tells the TagPoint whether it should inherit orientation from it's parent entity.
void | setInheritParentEntityScale (bool inherit)
| Tells the TagPoint whether it should inherit scaling factors from it's parent entity.
void | setParentEntity (Entity *pEntity)
void | updateFromParentImpl () const override
| Overridden from Node in order to include parent Entity transform.
Public Member Functions inherited from Ogre::v1::OldBone
| OldBone (const String &name, unsigned short handle, Skeleton *creator)
| Constructor, not to be used directly (use OldBone::createChild or Skeleton::createBone).
| OldBone (unsigned short handle, Skeleton *creator)
| Constructor, not to be used directly (use OldBone::createChild or Skeleton::createBone).
| ~OldBone () override
const Quaternion & | _getBindingPoseInverseOrientation () const
| Gets the inverted binding pose orientation.
const Vector3 & | _getBindingPoseInversePosition () const
| Gets the inverted binding pose position.
const Vector3 & | _getBindingPoseInverseScale () const
| Gets the inverted binding pose scale.
void | _getOffsetTransform (Matrix4 &m) const
| Gets the transform which takes bone space to current from the binding pose.
OldBone * | createChild (unsigned short handle, const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates a new OldBone as a child of this bone.
unsigned short | getHandle () const
| Gets the numeric handle for this bone (unique within the skeleton).
bool | isManuallyControlled () const
| Getter for mManuallyControlled Flag.
void | reset ()
| Resets the position and orientation of this OldBone to the original binding position.
void | setBindingPose ()
| Sets the current position / orientation to be the 'binding pose' ie the layout in which bones were originally bound to a mesh.
void | setManuallyControlled (bool manuallyControlled)
| Sets whether or not this bone is manually controlled.
Public Member Functions inherited from Ogre::v1::OldNode
| OldNode ()
| Constructor, should only be called by parent, not directly.
| OldNode (const String &name)
| Constructor, should only be called by parent, not directly.
virtual | ~OldNode ()
virtual const Quaternion & | _getDerivedOrientation () const
| Gets the orientation of the OldNode as derived from all parents.
virtual const Vector3 & | _getDerivedPosition () const
| Gets the position of the OldNode as derived from all parents.
virtual const Vector3 & | _getDerivedScale () const
| Gets the scaling factor of the OldNode as derived from all parents.
virtual const Matrix4 & | _getFullTransform () const
| Gets the full transformation matrix for this OldNode.
virtual void | _setDerivedOrientation (const Quaternion &q)
| Sets the final world orientation of the OldNode directly.
virtual void | _setDerivedPosition (const Vector3 &pos)
| Sets the final world position of the OldNode directly.
virtual void | _update (bool updateChildren, bool parentHasChanged)
| Internal method to update the OldNode.
virtual void | addChild (OldNode *child)
| Adds a (precreated) child scene OldNode to this OldNode.
virtual void | cancelUpdate (OldNode *child)
| Called by children to notify their parent that they no longer need an update.
virtual Quaternion | convertLocalToWorldOrientation (const Quaternion &localOrientation)
| Gets the world orientation of an orientation in the OldNode local space useful for simple transforms that don't require a child OldNode.
virtual Vector3 | convertLocalToWorldPosition (const Vector3 &localPos)
| Gets the world position of a point in the OldNode local space useful for simple transforms that don't require a child OldNode.
virtual Quaternion | convertWorldToLocalOrientation (const Quaternion &worldOrientation)
| Gets the local orientation, relative to this OldNode, of the given world-space orientation.
virtual Vector3 | convertWorldToLocalPosition (const Vector3 &worldPos)
| Gets the local position, relative to this OldNode, of the given world-space position.
virtual OldNode * | getChild (const String &name) const
| Gets a pointer to a named child OldNode.
virtual OldNode * | getChild (unsigned short index) const
| Gets a pointer to a child OldNode.
virtual ChildOldNodeIterator | getChildIterator ()
| Retrieves an iterator for efficiently looping through all children of this OldNode.
virtual ConstChildOldNodeIterator | getChildIterator () const
| Retrieves an iterator for efficiently looping through all children of this OldNode.
virtual bool | getInheritOrientation () const
| Returns true if this OldNode is affected by orientation applied to the parent OldNode.
virtual bool | getInheritScale () const
| Returns true if this OldNode is affected by scaling factors applied to the parent OldNode.
virtual const Quaternion & | getInitialOrientation () const
| Gets the initial orientation of this OldNode, see setInitialState for more info.
virtual const Vector3 & | getInitialPosition () const
| Gets the initial position of this OldNode, see setInitialState for more info.
virtual const Vector3 & | getInitialScale () const
| Gets the initial position of this OldNode, see setInitialState for more info.
virtual Listener * | getListener () const
| Gets the current listener for this OldNode.
virtual Matrix3 | getLocalAxes () const
| Gets a matrix whose columns are the local axes based on the OldNodes orientation relative to it's parent.
const String & | getName () const
| Returns the name of the OldNode.
virtual const Quaternion & | getOrientation () const
| Returns a quaternion representing the OldNodes orientation.
virtual OldNode * | getParent () const
| Gets this OldNode's parent (NULL if this is the root).
virtual const Vector3 & | getPosition () const
| Gets the position of the OldNode relative to it's parent.
virtual const Vector3 & | getScale () const
| Gets the scaling factor of this OldNode.
virtual Real | getSquaredViewDepth (const Camera *cam) const
| Helper function, get the squared view depth.
virtual const Any & | getUserAny () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
virtual unsigned short | numChildren () const
| Reports the number of child OldNodes under this one.
virtual void | pitch (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the OldNode around the X-axis.
virtual void | removeAllChildren ()
| Removes all child OldNodes attached to this OldNode.
virtual OldNode * | removeChild (const String &name)
| Drops the named child from this OldNode.
virtual OldNode * | removeChild (OldNode *child)
| Drops the specified child from this OldNode.
virtual OldNode * | removeChild (unsigned short index)
| Drops the specified child from this OldNode.
virtual void | requestUpdate (OldNode *child, bool forceParentUpdate=false)
| Called by children to notify their parent that they need an update.
virtual void | resetOrientation ()
| Resets the OldNodes orientation (local axes as world axes, no rotation).
virtual void | resetToInitialState ()
| Resets the position / orientation / scale of this OldNode to it's initial state, see setInitialState for more info.
virtual void | roll (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the OldNode around the Z-axis.
virtual void | rotate (const Quaternion &q, TransformSpace relativeTo=TS_LOCAL)
| Rotate the OldNode around an arbitrary axis using a Quarternion.
virtual void | rotate (const Vector3 &axis, const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the OldNode around an arbitrary axis.
virtual void | scale (const Vector3 &scale)
| Scales the OldNode, combining it's current scale with the passed in scaling factor.
virtual void | scale (Real x, Real y, Real z)
| Scales the OldNode, combining it's current scale with the passed in scaling factor.
virtual void | setInheritOrientation (bool inherit)
| Tells the OldNode whether it should inherit orientation from it's parent OldNode.
virtual void | setInheritScale (bool inherit)
| Tells the OldNode whether it should inherit scaling factors from it's parent OldNode.
virtual void | setInitialState ()
| Sets the current transform of this OldNode to be the 'initial state' ie that position / orientation / scale to be used as a basis for delta values used in keyframe animation.
virtual void | setListener (Listener *listener)
| Sets a listener for this OldNode.
virtual void | setOrientation (const Quaternion &q)
| Sets the orientation of this OldNode via a quaternion.
virtual void | setOrientation (Real w, Real x, Real y, Real z)
| Sets the orientation of this OldNode via quaternion parameters.
virtual void | setPosition (const Vector3 &pos)
| Sets the position of the OldNode relative to it's parent.
virtual void | setPosition (Real x, Real y, Real z)
| Sets the position of the OldNode relative to it's parent.
virtual void | setScale (const Vector3 &scale)
| Sets the scaling factor applied to this OldNode.
virtual void | setScale (Real x, Real y, Real z)
| Sets the scaling factor applied to this OldNode.
virtual void | setUserAny (const Any &anything)
virtual void | translate (const Matrix3 &axes, const Vector3 &move, TransformSpace relativeTo=TS_PARENT)
| Moves the OldNode along arbitrary axes.
virtual void | translate (const Matrix3 &axes, Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| Moves the OldNode along arbitrary axes.
virtual void | translate (const Vector3 &d, TransformSpace relativeTo=TS_PARENT)
| Moves the OldNode along the Cartesian axes.
virtual void | translate (Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| Moves the OldNode along the Cartesian axes.
virtual void | yaw (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the OldNode around the Y-axis.

## Additional Inherited Members
Public Types inherited from Ogre::v1::OldNode
typedef MapIterator< ChildOldNodeMap > | ChildOldNodeIterator
typedef unordered_map< String, OldNode * >::type | ChildOldNodeMap
typedef ConstMapIterator< ChildOldNodeMap > | ConstChildOldNodeIterator
enum | TransformSpace { TS_LOCAL , TS_PARENT , TS_WORLD }
| Enumeration denoting the spaces which a transform can be relative to. More...
Static Public Member Functions inherited from Ogre::v1::OldNode
static void | processQueuedUpdates ()
| Process queued 'needUpdate' calls.
static void | queueNeedUpdate (OldNode *n)
| Queue a 'needUpdate' call to a OldNode safely.

## Detailed Description

A tagged point on a skeleton, which can be used to attach entities to on specific other entities.

Remarks
  A Skeleton, like a Mesh, is shared between Entity objects and simply updated as required when it comes to rendering. However there are times when you want to attach another object to an animated entity, and make sure that attachment follows the parent entity's animation (for example, a character holding a gun in his / her hand). This class simply identifies attachment points on a skeleton which can be used to attach child objects.

  The child objects themselves are not physically attached to this class; as it's name suggests this class just 'tags' the area. The actual child objects are attached to the Entity using the skeleton which has this tag point. Use the Entity::attachMovableObjectToBone method to attach the objects, which creates a new TagPoint on demand.

## Constructor & Destructor Documentation

## ◆ TagPoint()

Ogre::v1::TagPoint::TagPoint | ( | unsigned short | handle,
|  | Skeleton * | creator )

## ◆ ~TagPoint()

Ogre::v1::TagPoint::~TagPoint | ( |  | ) |
| override

## Member Function Documentation

## ◆ _getFullLocalTransform()

const Matrix4 & Ogre::v1::TagPoint::_getFullLocalTransform | ( |  | ) | const

Gets the transform of this node just for the skeleton (not entity).

## ◆ getChildObject()

MovableObject * Ogre::v1::TagPoint::getChildObject | ( |  | ) | const

## ◆ getInheritParentEntityOrientation()

bool Ogre::v1::TagPoint::getInheritParentEntityOrientation | ( |  | ) | const

Returns true if this TagPoint is affected by orientation applied to the parent entity.

## ◆ getInheritParentEntityScale()

bool Ogre::v1::TagPoint::getInheritParentEntityScale | ( |  | ) | const

Returns true if this TagPoint is affected by scaling factors applied to the parent entity.

## ◆ getLights()

const LightList & Ogre::v1::TagPoint::getLights | ( |  | ) | const

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks
  Directional lights, which have no position, will always be first on this list.

## ◆ getParentEntity()

Entity * Ogre::v1::TagPoint::getParentEntity | ( |  | ) | const

## ◆ getParentEntityTransform()

const Matrix4 & Ogre::v1::TagPoint::getParentEntityTransform | ( |  | ) | const

Gets the transform of parent entity.

## ◆ needUpdate()

void Ogre::v1::TagPoint::needUpdate | ( | bool | forceParentUpdate = false | ) |
| overridevirtual

To be called in the event of transform changes to this OldNode that require it's recalculation.

Remarks
  This not only tags the OldNode state as being 'dirty', it also requests it's parent to know about it's dirtiness so it will get an update next time.

Parameters

  forceParentUpdate | Even if the OldNode thinks it has already told it's parent, tell it anyway

Reimplemented from Ogre::v1::OldBone.

## ◆ setChildObject()

void Ogre::v1::TagPoint::setChildObject | ( | MovableObject * | pObject | ) |

## ◆ setInheritParentEntityOrientation()

void Ogre::v1::TagPoint::setInheritParentEntityOrientation | ( | bool | inherit | ) |

Tells the TagPoint whether it should inherit orientation from it's parent entity.

Parameters

  inherit | If true, this TagPoint's orientation will be affected by its parent entity's orientation. If false, it will not be affected.

## ◆ setInheritParentEntityScale()

void Ogre::v1::TagPoint::setInheritParentEntityScale | ( | bool | inherit | ) |

Tells the TagPoint whether it should inherit scaling factors from it's parent entity.

Parameters

  inherit | If true, this TagPoint's scaling factors will be affected by its parent entity's scaling factors. If false, it will not be affected.

## ◆ setParentEntity()

void Ogre::v1::TagPoint::setParentEntity | ( | Entity * | pEntity | ) |

## ◆ updateFromParentImpl()

void Ogre::v1::TagPoint::updateFromParentImpl | ( |  | ) | const
| overridevirtual

Overridden from Node in order to include parent Entity transform.

Reimplemented from Ogre::v1::OldNode.

The documentation for this class was generated from the following file:

- OgreTagPoint.h